/****************************************************************************
 * 이벤트 등록
 ****************************************************************************/
function fn_insertWebEvent(){
    if("Y"!=insertUseYn){
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

    let title          = $("#title").val();
    let content         = $("#content").val();
	let hashtag         = $("#hashtag").val();
	let thumbnail_bottom_txt = $("#thumbnail-bottom-txt").val();
	let categoryNo = $("select[name=categorylist]").val();
	
	var treatmentlen = $("input[name=treatmentlist]").length;
	var treatmentlist = new Array(treatmentlen);
	for(var i=0; i<treatmentlen; i++){                          
		treatmentlist[i] = $("input[name=treatmentlist]").eq(i).val();        
	}
	
	var treatmentprocedurelen = $("input[name=treatmentprocedurelist]").length;
	var treatmentprocedurelist = new Array(treatmentprocedurelen);
	for(var i=0; i<treatmentprocedurelen; i++){                          
		treatmentprocedurelist[i] = $("input[name=treatmentprocedurelist]").eq(i).val();        
	}
	
    //let eventStartDate  = $("#eventStartDate").val();
    //let eventEndDate       = $("#eventEndDate").val();
    let file            = $("#file")[0].files[0];
	let content_file            = $("#content_file")[0].files[0];

	if(true != fn_emptyCheck(categoryNo)) {
        modalEvent.warning("등록", "카테고리를 입력하세요.");
        return;
    }
    if(true != fn_emptyCheck(title)) {
        modalEvent.warning("등록", "제목을 입력하세요.");
        return;
    }
    /** 20251024 이상우팀장 요청으로 인해 필수입력 validation 삭제
    if(true != fn_emptyCheck(content)) {
        modalEvent.warning("등록", "내용을 입력하세요.");
        return;
    }
	if(true != fn_emptyCheck(hashtag)) {
        modalEvent.warning("등록", "해시태그를 입력하세요.");
        return;
    }
	if(true != fn_emptyCheck(thumbnail_bottom_txt)) {
        modalEvent.warning("등록", "썸네일 하단 내용을 입력하세요.");
        return;
    }

    if(true != fn_emptyCheck(file)) {
        modalEvent.warning("등록", "썸네일 이미지가 첨부되지 않았습니다.");
        return;
    }else{
        for(let i=0; i<file.length; i++){
            let fileSize = file[i].size;
            if(fileSize > fn_maxFileSize()){
                modalEvent.warning("", "파일정보 용량이 50MB를 넘습니다. 업로드가 불가능합니다.");

                return;
            }
        }
    }
	if(true != fn_emptyCheck(content_file)) {
	        modalEvent.warning("등록", "컨텐츠 이미지가 첨부되지 않았습니다.");
	        return;
	    }else{
	        for(let i=0; i<content_file.length; i++){
	            let fileSize = content_file[i].size;
	            if(fileSize > fn_maxFileSize()){
	                modalEvent.warning("", "파일정보 용량이 50MB를 넘습니다. 업로드가 불가능합니다.");

	                return;
	            }
	        }
	    }
	*/
    modalEvent.info("등록", categorytitle + " 정보를 등록하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
		formData.append("categoryDivCd", categoryDivCd);
		formData.append("categoryNo", categoryNo);
        formData.append("title", title);
        formData.append("content", content);
		formData.append("hashtag", hashtag);
		formData.append("thumbnail_bottom_txt", thumbnail_bottom_txt);		
        formData.append("file", file);
		formData.append("content_file", content_file);
		formData.append("treatmentlist", treatmentlist);
		formData.append("treatmentprocedurelist", treatmentprocedurelist);
		formData.append("oldCrmItemId", $("#oldCrmItemId").val());
		formData.append("ordNo", $("#ordNo").val());

        $.ajax({
            url: encodeURI('/contentsBbs/putContentsBbs.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("등록 성공", data.msgDesc, function(){
                        fn_selectListWebTreatmentPetitIntro();
                    });
                }
                else{
                    modalEvent.danger("등록 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("등록 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * html 에디터 이미지 업로드시
 ****************************************************************************/
function uploadSummernoteImageFileNoticeInsert(files, editor){
    Object.values(files).forEach(file => {
        let formData = new FormData();
        formData.append('menuClass', menuClass);
        formData.append('file', file);
        $.ajax({
            url: encodeURI('/webtreatmentpetit/uploadFile.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function (data) {
                if ('0' == data.msgCode) {
                    $(editor).summernote('insertImage', data.rows.filePath, function ($image) {
                    });
                }
            },
            error: function (xhr, status, error) {
                modalEvent.danger('오류', '이미지 업로드 중 오류가 발생했습니다.');
            },
            beforeSend: function () {
                // 로딩열기
                $(".loading-image-layer").show();
            },
            complete: function () {
                // 로딩닫기
                $(".loading-image-layer").hide();
            }
        });
    })
}

/****************************************************************************
 * 배너 이미지 미리보기
 ****************************************************************************/
function fn_filePreview(width, height, obj){
	let file = "";
	if(obj == '.img_box'){
		file =  $("#file")[0].files[0];
	} else {
		file =  $("#content_file")[0].files[0];
	}
	
   if(file){
       $(obj).html('');
       const reader = new FileReader();

       reader.onload = function (e) {
           // 이미지 요소를 생성하고 미리보기 추가
           const img = document.createElement('img');
           img.src = e.target.result;
           img.style.width = width; // 원하는 크기로 조정
           img.style.height = height;
           $(obj).append(img);
       };

       // 파일을 읽기 시작
       reader.readAsDataURL(file);
   }
}
/****************************************************************************
 * 배너 이미지 삭제
 ****************************************************************************/
function fn_removePreview(){
    $("#file").val('');
    $('.img_box').html('');
}


/****************************************************************************
 * 배너 이미지 미리보기
 ****************************************************************************/
function fn_fileContentPreview(){
   const file =  $("#content_file")[0].files[0];
   if(file){
       $('.file_box').html(file.name);
   }
}
/****************************************************************************
 * 배너 이미지 삭제
 ****************************************************************************/
function fn_removeContentPreview(){
    $("#content_file").val('');
    $('.file_box').html('');
}

/****************************************************************************
 * 리스트 화면으로 이동.
 ****************************************************************************/
function fn_selectListWebTreatmentPetitIntro(){
    if("Y"==selectUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/contentsBbs/moveContentsBbsList.do"+pagingParam);
    }else{
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }
}

/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#eventStartDate", "#eventEndDate");

    $('#summernote').summernote({
        height: 540,
        callbacks: {	//여기 부분이 이미지를 첨부하는 부분
            onImageUpload : function(files) {
                uploadSummernoteImageFileNoticeInsert(files, this);
            }
        },
    });
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $('.btnCancle').on("click", function(){
        fn_selectListWebTreatmentPetitIntro();
    });

    $('.btnSave').on("click", function(){
        fn_insertWebEvent();
    });
    $('#delete_btn').on("click", function(){
        fn_removePreview();
    });
    $('#file').on('change', function(e) {
        fn_filePreview('800px', '450px', '.img_box');
    })
	$('#content_delete_btn').on("click", function(){
        fn_removeContentPreview();
    });
    $('#content_file').on('change', function(e) {
        fn_filePreview('100%', '100%', '.file_box');
    })
}

/****************************************************************************
 * 시술 목록 팝업
 ****************************************************************************/
function listOpen(){
    let reqParam = {};
    treatmentSelectModal.popup(function (obj, reqParam) {
		const childDivCount = $("#treatmentlist > div").length;
		if($("#" + obj.treatmentProcedureId).length > 0){
			modalEvent.warning("", "이미 시술정보가 있습니다.");
			return;
		}
		var htmlstring = `<div id="treatment`+childDivCount+`">
								<input type="checkbox" id="`+obj.treatmentProcedureId+`" name="treatment">
								<input type="hidden" name="treatmentprocedurelist" value="`+obj.treatmentProcedureId+`">
								<input type="hidden" name="treatmentlist" value="`+obj.treatmentId+`">
								<label for="`+obj.treatmentProcedureId+`">`+obj.treatmentNm + `-` + obj.price.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") + `-` + obj.discountPrice.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") +`</label>
							</div>`;
		$('#treatmentlist').append(htmlstring);
    }, reqParam);
}
function fn_removeRow(){
	 $('input:checkbox[name="treatment"]').each(function() {      		
		if(this.checked){//checked 처리된 항목의 값            
			$(this).parent().remove();    
		} 
	});
	
}


$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});